dbSelectionInfoTimeout = null;
var currentlySelected = {
    titles: [],
    uids: [],
    type: null
}

var shoppingCart = {
    contents: {
        titles: [],
        uids: [],
        types: []
    }
}

var graphSelection = {
    graphType: null,
    graphData: null,
    dataAvailable: false
}

var mockupData = {
    muData1: [5, 7, 9, 4], //pie charts
    muData2: [4,20,50,18,8], //bar charts
    muData3: [24,20,26,35,36,29,25,16],    //radar charts
    muData4 : [8,34,6,56,3,23] // rose charts
}

function infoPanelTimeout(event) {
    // If no event, crash.
    if (event == undefined || event == null) return;
    // Cancel previous timeout if present.
    if (dbSelectionInfoTimeout) {
        window.clearTimeout(dbSelectionInfoTimeout);
    }
    // Gather parameters about event.
    var dbSelectionInfoTime = 500;
    var selectBox = event.target;
    var values = getMultipleListValue(selectBox).values;
    var titles = getMultipleListValue(selectBox).titles;
    var uid = values[values.length-1];
    var type;
    
    switch (selectBox.id) {
        case "dbSessionInstancesList":
            // This should be session instance, not session. Testing purpose only.
            type = "Session";
            break;
        case "dbGamedataList":
            // This is obviously not the real type, change before committing
            type = "Application";
            break;
        default:
            var value = values[0];
            var opt;
            for (var n = 0; n < selectBox.options.length; n++) {
                if (selectBox.options[n].value == value) {
                    opt = selectBox.options[n];
                    type = opt.attributes[1].value;
                }
            }
            if (type == null || type == undefined) //error?!?!?!
                break;
    }
    currentlySelected.uids = values;
    currentlySelected.titles = titles;
    currentlySelected.type = type;
    // Set timeout of 500ms, then execute ajaxInfoRequest with previously gathered parameters.
    dbSelectionInfoTimeout = window.setTimeout(ajaxInfoRequest, dbSelectionInfoTime, uid, ge("dbInfoPanelContent"), type);
    
}

function getMultipleListValue(element) {
    // Get multiple values from multiple select box
    //TODO: 
    var result = {
        values: [],
        titles: []
    }
        
    for (var i = 0; i < element.options.length; i++) {
        if (element.options[i].selected == true) {
            result.values.push(element.options[i].value);
            result.titles.push(element.options[i].text);
        }
    }
    return result;
}

function addDataToList() {
    // Take selected objects and add to shopping cart
        
    // set element
    var element;
    switch (currentlySelected.type){
        case "Session":
            element = ge("dbSessionInstancesList");
            break;
        case "Application":
            element = ge("dbGamedataList");
            break;
        default:
            // ???
            break;
    }
    var uid;
    while (uid = currentlySelected.uids.pop()) {
        // Add to shopping cart
        shoppingCart.contents.uids.push(uid);
        shoppingCart.contents.titles.push(currentlySelected.titles.pop());
        shoppingCart.contents.types.push(currentlySelected.type);
        
        // Remove option from list
        for (var i = 0; i < element.options.length; i++) {
            if (element.options[i].value == uid) {
                element.remove(i);
                break;
            }
        }
    }
    
    // Then add display of shopping cart contents
    drawShoppingCart();
    
}

function removeFromList(event) {
    if (event == null || event == undefined) return;
    
    var id = event.target.parentNode.id;
    var uid = id.split("shoppingCartItem")[1];
    // find index, remove from object
    var indexInCart = shoppingCart.contents.uids.indexOf(uid);
    var tempTitle = shoppingCart.contents.titles[indexInCart];
    var cn = confirm("Are you sure you want to remove: "+tempTitle+"?");
    if (cn == false) return;
    
    
    shoppingCart.contents.uids.splice(indexInCart, 1);
    var title = shoppingCart.contents.titles.splice(indexInCart, 1)[0];
    var type = shoppingCart.contents.types.splice(indexInCart, 1)[0];
    //Then replace element back into relevant list
    // First set element
        
    var element;
    switch (type){
        case "Session":
            element = ge("dbSessionInstancesList");
            break;
        case "Application":
            element = ge("dbGamedataList");
            break;
        default:
            // ???
            break;
    }
    
    var option = ce("option");
    option.value = uid;
    option.text = title;
    element.add(option,null);
    
    
    
    // Lastly, refresh
    drawShoppingCart();
}

function drawShoppingCart() {
    var scElement = ge("shoppingCartContent");
    scElement.innerHTML = "";
    for (var i = 0; i < shoppingCart.contents.uids.length; i++) {
        var newLine = ce("div");
        newLine.className = "shoppingCartItem";
        newLine.id = "shoppingCartItem"+shoppingCart.contents.uids[i];
        var icon = ce("image");
        icon.src = "images/ui/DeleteIcon.gif";
        icon.addEventListener("click", function(event){
            // TODO: Actually write this function
            removeFromList(event);
        }, false);
        var titleField = ce("text");
        titleField.innerHTML = shoppingCart.contents.titles[i];
        newLine.appendChild(icon);
        newLine.appendChild(titleField);
        scElement.appendChild(newLine);
    }
    
    // reset type after empty
    currentlySelected.type = null;
}
    
function configureDashboard() {
    var data = JSON.stringify(shoppingCart);
    var form = ce("form");
    //changed to dashboardGraphSelection.php
    form.action = "dashboardGraphSelection.php";
    form.method = "POST";
    var input = ce("input");
    input.type = "hidden";
    input.name = "selectedData";
    input.value = data;
    form.appendChild(input);
    form.submit();
}

//function goto dashboard
function gotoDashboard() {
    var data = JSON.stringify(doorstuurData);
    var form = ce("form");
    //changed to dashboardGraphSelection.php
    form.action = "dashboardOverview.php";
    form.method = "POST";
    var input = ce("input");
    input.type = "hidden";
    input.name = "doorstuurData";
    input.value = data;
    form.appendChild(input);
    form.submit();
//alert("Graph type is now: "+graphSelection);
    
}

function changeGraphType(type) {
    // If different graph type, clear canvas 1.
    
    switch (type.toLowerCase()){
        case "bar":
            graphSelection.graphType = "Bar";
            break;
        case "radar":
            graphSelection.graphType = "Radar";
            break
        case "pie":
            graphSelection.graphType = "Pie";
            break;
        case "rose":
            graphSelection.graphType = "Rose";
            break;
        default:
            break;
    }
    
    
    var data = formatGraphData();
    drawGraph('chart1', 450, 200, graphSelection.graphType, data);
    
// alert("Graph type is now: "+graphSelection.graphType);
}

function formatGraphData() {
    /*
     * if (data.available == false) {
     * graphSelection.dataAvailable = false;
     * insertStandardPlaceholderData();
     * }
     * else {
     * FormatDataCorrectly();
     * }
     */
    // temporary!!!;
    
    switch (graphSelection.graphType) {
        case "Bar":
            graphSelection.graphData = mockupData.muData2;
            break;
        case "Pie":
            graphSelection.graphData = mockupData.muData1;
            break;
        case "Radar":
            graphSelection.graphData = mockupData.muData3;
            break;
        case "Rose":
            graphSelection.graphData = mockupData.muData4;
            break;
    }
    
    return graphSelection.graphData;
    
//alert("Data is now being formatted");
}

function drawGraph(name, sizeX, sizeY, type, data) {
    //delete old graph
    
    var oldGraph = ge("chart1");
    if (oldGraph) oldGraph.parentNode.removeChild(oldGraph);
    
    var canvas = ce("canvas");
    canvas.id = name;
    canvas.width = sizeX;
    canvas.height = sizeY;
    var parentElement = ge("graphDisplay");
    parentElement.appendChild(canvas);
    
    //js calls
    var chart1;
    switch (type) {
        case "Bar":
            chart1 = new RGraph.Bar(name, data);
            chart1.Set('chart.labels', ['Bad','Subpar','Average','Above average','Good']);
            chart1.Set('chart.colors', ['#77f', '#7f7', '#f77']);
            break;
        case "Pie":
            chart1 = new RGraph.Pie(name, data);
            chart1.Set('chart.labels', ['20-30 (20 participants)', '30-40 (28 participants)', '40-50 (36 participants)', '50+ (16 participants)']);
            chart1.Set('chart.colors', ['#77f', '#7f7', '#f77', '#ff7']);
            break;
        case "Radar":
            chart1 = new RGraph.Radar(name, data);
            chart1.Set('chart.colors.alpha', '50%');
            chart1.Set('chart.labels',['Bram','Paula','Jules','Joel','Tyrone','Henk','Darcy','Frans']);
            chart1.Set('chart.colors', ['rgba(112,112,240,0.5)', 'rgba(112,240,112,0.5)', 'rgba(240,112,112,0.5)']);
            break;
        case "Rose":
            chart1 = new RGraph.Rose(name, data);
            chart1.Set('chart.labels', ['1 fault', '2 faults', '3 faults', '4 faults', '5 faults', '6 faults']);
            chart1.Set('chart.colors', ['#77f', '#7f7', '#f77']);
            break;
        default:
            break;
    }
    
    
    
    chart1.Set('chart.shadow', false);
    chart1.Set('chart.shadow.blur', 0);
    chart1.Set('chart.shadow.offsetx', 0);
    chart1.Set('chart.shadow.offsety', 0);
    chart1.Set('chart.shadow.color', '#aaa');
    chart1.Set('chart.yaxispos', 'right');
    chart1.Set('chart.strokestyle', 'rgba(0,0,0,0)');
    chart1.Set('chart.gutter.left', 5);
    chart1.Set('chart.gutter.right', 45);
    chart1.Draw();
    
    return chart1;
    
}

var doorstuurData = {
    graphs: [],
    count: null
}



function addToDashboard() {
    alert('You saved "'+graphSelection.graphType.toLowerCase()+' chart" to dashboard!');    
    doorstuurData.graphs.push(["graph"+doorstuurData.count+1, 450, 200, graphSelection.graphType, graphSelection.graphData]);
    doorstuurData.count++;
}
//Helper

function checkBack(url) {
    if (confirm("Are you sure you want to go back? You will lose your selected data.")) {
        window.location = url ;
    }
}

